# Range Demo

- order: 0

普通区间选择器。

---

````js

/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import View from 'nuke-view';
import Page from 'nuke-page';
import Button from 'nuke-button';
import Text from 'nuke-text';
import Range from 'nuke-range';

let App = class NukeDemoIndex extends Component {
    constructor() {
      super();
      this.state = {
          value:30
      };
    }
    changeValue(){
      this.setState({
          value:80
      })
    }
    onChange(value){
      console.log('拖动停止',value);
      this.setState({
        value:value
      })
    }
    onProcess(value){
      console.log(value);
      this.setState({
        value:value
      });
    }
    render() {
        return (
          <Page title="Range">
            <Page.Intro main="无默认值"></Page.Intro>
            <View style={{justifyContent:'center',alignItems:'center',flex:1}}>
              <Range  slider="single" min={0} max={100}  style={{width:500}}  highPerformance={true}/>
            </View>
            <Page.Intro main="有默认值"></Page.Intro>
            <View style={{justifyContent:'center',alignItems:'center',flex:1}}>
                  <Range  slider="single" min={0} max={100} defaultValue={80} style={{width:500}} highPerformance={true}/>
            </View>
            <Page.Intro main="受控使用"></Page.Intro>
            <View style={{justifyContent:'center',alignItems:'center',flex:1}}>
                <Range  slider="single" min={0} max={100} value={this.state.value} style={{width:500}} onProcess={this.onProcess.bind(this)} onChange={this.onChange.bind(this)} highPerformance={true}/>
                <Text style={{marginTop:30}}>当前值{this.state.value}</Text>
                <Button style={{marginTop:30,marginBottom:50}} type="primary" onPress={this.changeValue.bind(this)}>点我设置到80</Button>
            </View>
            <Page.Intro main="样式自定义"></Page.Intro>
            <View style={{justifyContent:'center',alignItems:'center',flex:1}}>
              <Range  slider="single" min={0} max={100} defaultValue={80} style={{width:500}} handlerStyle={{backgroundColor:'pink',width:56,height:56}} barStyle={{backgroundColor:'#ff6600',height:6}} afterBarStyle={{backgroundColor:'#999999',height:6}}/>
            </View>
          </Page>
        );
    }
}

render(<App/>);

````
