'use strict';

function VariableMix(theme) {
  var Core = theme.Core;
  var ComponentCustomStyle = theme.Range || {};

  /**
   * 区间选择器
   * @namespace component
   * @property module range
   * @property tag Range
   * @property category component
   */

  var variables = {
    /*
    * height
    * @property namespace size/bar
    */
    'bar-height': 4,
    /*
    * backgroundColor
    * @property namespace statement/normal
    */

    'handler-bg-color': Core['color-white'],
    /*
    * size
    * @property namespace size/handle
    */
    'handler-size': Core['s-6'],
    /*
    * size
    * @property namespace size/handle
    */
    'handler-border-width': 1,
    /*
    * border-color
    * @property namespace statement/handle
    */
    'handler-border-color': Core['color-line1-1'],
    /*
     * color
     * @property namespace statement/disabled
     */
    'disabled-handler-bg-color': Core['color-fill1-3'],

    /*
    * bar-underlay
    * @property namespace statement
    */
    'line-bar-bg-color': Core['color-line1-3'],
    /*
       * bar-overlay
       * @property namespace statement
       */
    'bar-overlay-color': Core['color-brand1-9'],

    /*
     * padding(l,r)
     * @property namespace size/bounding
     */
    'padding-left-right': Core['s-4'],
    /*
    * padding(t,b)
    * @property namespace size/bounding
    */
    'padding-top-bottom': Core['s-2']
  };

  // should alway use var statement to carray a assigngg
  var variable = Object.assign(variables, ComponentCustomStyle);

  return variable;
}

module.exports = VariableMix;