'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeEnv = require('nuke-env');

var _nukeEnv2 = _interopRequireDefault(_nukeEnv);

var _nukeThemeProvider = require('nuke-theme-provider');

var _styles = require('../styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var isWeb = _nukeEnv2.default.isWeb,
    appInfo = _nukeEnv2.default.appInfo;

var isIOS = appInfo.platform.toLowerCase() === 'ios';
var expressionBinding = {};
try {
  expressionBinding = require('@weex-module/expressionBinding');
} catch (e) {}

/**
 * Range
 * @description  区间滑块
 */

var Range = function (_Component) {
  _inherits(Range, _Component);

  function Range(props) {
    _classCallCheck(this, Range);

    var _this = _possibleConstructorReturn(this, (Range.__proto__ || Object.getPrototypeOf(Range)).call(this, props));

    _this.getRange = function () {
      if (_this.props.slider !== 'double') {
        return {
          rangeX1: [0, _this.length]
        };
      }
      return {
        rangeX1: [0, _this.state.end - _this.state.minDiffX],
        rangeX2: [_this.state.start + _this.state.minDiffX, _this.length]
      };
    };

    _this.restrictValue = function (range, value) {
      if (range && range.length && range.length === 2) {
        if (value < range[0]) {
          return range[0];
        } else if (value > range[1]) {
          return range[1];
        }
        return value;
      }
      return;
    };

    _this.weexStartHandler1 = _this.weexStartHandler1.bind(_this);
    _this.weexStartHandler2 = _this.weexStartHandler2.bind(_this);
    _this.weexEndHandler = _this.weexEndHandler.bind(_this);
    _this.bindExp = _this.bindExp.bind(_this);
    _this.enableBinding = _this.enableBinding.bind(_this);
    _this.renderHandler = _this.renderHandler.bind(_this);
    _this.state = {
      start: 0,
      end: 0,
      active: false,
      value: props.value || props.defaultValue || 0,
      barWidth: 0,
      timeout: 100,
      left: 0,
      selectRange: [0, 0],
      minDiffX: 0
    };
    _this.selectRange = [0, 0];

    _this.dpr = 1;
    _this.ep = true;
    return _this;
  }

  _createClass(Range, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.block1 = (0, _rax.findDOMNode)(this.refs['slide-block-1']); // 左侧滑块
      this.block2 = (0, _rax.findDOMNode)(this.refs['slide-block-2']); // 右侧滑块
      this.valueBar = (0, _rax.findDOMNode)(this.refs['slide-value-bar']); // 黄色值条
      this.barContainer = (0, _rax.findDOMNode)(this.refs['slide-bar-container']); // 滚动条容器

      this.initBaseEnv(); // ep设置，滑块位置
    }
    // 根据value和length计算x方向偏移值

  }, {
    key: 'getDistanceByValue',
    value: function getDistanceByValue(value) {
      return (value - this.props.min) / (this.props.max - this.props.min) * this.length;
    }
  }, {
    key: 'getValueByDistance',
    value: function getValueByDistance(diffX) {
      return Math.round(diffX / this.length * (this.props.max - this.props.min) + this.props.min);
    }
  }, {
    key: 'initBaseEnv',
    value: function initBaseEnv() {
      var _this2 = this;

      var _props = this.props,
          slider = _props.slider,
          min = _props.min,
          max = _props.max,
          themeStyle = _props.themeStyle,
          style = _props.style;

      this.length = parseInt(style.width || themeStyle.container.width, 10); // 可滑动的距离，未计算padding
      this.leftDiffX = 0;
      var newData = { selectRange: this.state.selectRange };
      if (!slider || slider === 'single') {
        newData.start = this.getDistanceByValue(this.state.value);
      } else if (slider === 'double') {
        newData.start = this.getDistanceByValue(this.state.value[0]);
        newData.end = this.getDistanceByValue(this.state.value[1]);
        newData.barWidth = newData.end - newData.start;
        this.selectRange = this.state.value || this.state.defaultValue;
        newData.minDiffX = this.state.minDiffX / (max - min) * this.length;
      } else {
        throw new Error('unsupport slider type,use single or double replace');
      }
      if (appInfo.platform === 'android') {
        newData.timeout = 250;
      }
      this.setState(_extends({}, newData));

      if (this.ep && appInfo.platform !== 'android') {
        this.enableBinding();
        this.bindExp();
      }
      // android渲染性能不佳，动画绑定延时进行。
      if (this.ep && appInfo.platform === 'android') {
        setTimeout(function () {
          _this2.enableBinding();
          _this2.bindExp();
        }, 100);
      }
    }
  }, {
    key: 'enableBinding',
    value: function enableBinding() {
      var _this3 = this;

      expressionBinding.enableBinding(this.block1.ref, 'pan');
      this.block2 && expressionBinding.enableBinding(this.block2.ref, 'pan');
      expressionBinding.enableBinding(this.valueBar.ref, 'pan');
      setTimeout(function () {
        var dom = require('@weex-module/dom');
        dom.getComponentRect(_this3.barContainer, function (option) {
          var left = option.size.left;

          _this3.leftDiffX = left;
        });
      }, 100);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this4 = this;

      if (nextProps.value != this.props.value && !this.paning) {
        this.setState({
          value: nextProps.value
        }, function () {
          _this4.initBaseEnv();
        });
      }
    }
  }, {
    key: 'computeContainerStyle',
    value: function computeContainerStyle() {
      var _props2 = this.props,
          handlerStyle = _props2.handlerStyle,
          style = _props2.style,
          themeStyle = _props2.themeStyle;

      var handlerWidth = handlerStyle.width ? handlerStyle.width : themeStyle.slideBlock.width;
      var handlerHeight = handlerStyle.height ? handlerStyle.height : themeStyle.slideBlock.height;
      return _extends({}, style, {
        width: this.length + handlerWidth,
        height: handlerHeight
      });
    }
  }, {
    key: 'computRangeBarStyle',
    value: function computRangeBarStyle() {
      var _props3 = this.props,
          afterBarStyle = _props3.afterBarStyle,
          themeStyle = _props3.themeStyle;

      return _extends({}, themeStyle.bar, themeStyle.invalid, afterBarStyle, {
        width: this.length
      });
    }
  }, {
    key: 'computValueBarStyle',
    value: function computValueBarStyle() {
      var left = 0;
      var width = 0;
      var _props4 = this.props,
          slider = _props4.slider,
          disabled = _props4.disabled,
          barStyle = _props4.barStyle,
          themeStyle = _props4.themeStyle;

      if (!slider || slider === 'single') {
        width = this.state.start;
      } else {
        left = this.state.start;
        width = this.state.end - this.state.start;
      }
      return Object.assign({}, themeStyle.bar, {
        width: width,
        transform: 'translateX(' + left / this.dpr + 'px)'
      }, disabled ? themeStyle.disabled : themeStyle.valid, barStyle);
    }
  }, {
    key: 'computBlock1Style',
    value: function computBlock1Style() {
      return { transform: 'translateX(' + this.state.start / this.dpr + 'px)' };
    }
  }, {
    key: 'computBlock2Style',
    value: function computBlock2Style() {
      return { transform: 'translateX(' + this.state.end / this.dpr + 'px)' };
    }
  }, {
    key: 'renderHandler',
    value: function renderHandler() {
      var _props5 = this.props,
          handlerStyle = _props5.handlerStyle,
          style = _props5.style,
          slider = _props5.slider,
          themeStyle = _props5.themeStyle;
      // native handle

      var blockEle1Style = Object.assign({}, themeStyle.slideBlock, isIOS ? themeStyle.slideBlockIOS : {}, handlerStyle, this.computBlock1Style());
      var blockEle2Style = Object.assign({}, themeStyle.slideBlock, isIOS ? themeStyle.slideBlockIOS : {}, handlerStyle, this.computBlock2Style());
      var blockEle1 = (0, _rax.createElement)(
        _nukeView2.default,
        {
          ref: 'slide-block-1',
          onTouchStart: this.weexStartHandler1,
          onTouchEnd: this.weexEndHandler,
          style: blockEle1Style,
          preventMoveEvent: true
        },
        (0, _rax.createElement)(_nukeView2.default, null)
      );
      var blockEle2 = (0, _rax.createElement)(
        _nukeView2.default,
        {
          ref: 'slide-block-2',
          t: 'siwp2',
          onTouchStart: this.weexStartHandler2,
          onTouchEnd: this.weexEndHandler,
          style: blockEle2Style,
          preventMoveEvent: true
        },
        (0, _rax.createElement)(_nukeView2.default, null)
      );

      if (slider !== 'double') {
        return blockEle1;
      }
      return [blockEle1, blockEle2];
    }
  }, {
    key: 'render',
    value: function render() {
      var _props6 = this.props,
          style = _props6.style,
          disabled = _props6.disabled,
          slider = _props6.slider,
          handlerStyle = _props6.handlerStyle,
          themeStyle = _props6.themeStyle,
          others = _objectWithoutProperties(_props6, ['style', 'disabled', 'slider', 'handlerStyle', 'themeStyle']);

      return (0, _rax.createElement)(
        _nukeView2.default,
        {
          ref: 'slide-bar-container',
          style: [themeStyle.container, this.computeContainerStyle()]
        },
        (0, _rax.createElement)(
          _nukeView2.default,
          { style: [themeStyle.range, this.computRangeBarStyle()] },
          (0, _rax.createElement)(
            _nukeView2.default,
            { ref: 'slide-value-bar', style: [this.computValueBarStyle()] },
            (0, _rax.createElement)(_nukeView2.default, { ref: 'slide-value-bar-2' })
          )
        ),
        this.renderHandler()
      );
    }
  }, {
    key: 'weexStartHandler1',
    value: function weexStartHandler1() {
      var _this5 = this;

      if (isWeb) return;
      var slider = this.props.slider;

      var dom = require('@weex-module/dom');
      this.paning = true;
      this.firstInterval = setInterval(function () {
        if (slider !== 'double') {
          dom.getComponentRect(_this5.valueBar, function (option) {
            var width = option.size.width;

            var value = _this5.getValueByDistance(width);
            _this5.props.onProcess && _this5.props.onProcess(value);
          });
        } else {
          dom.getComponentRect(_this5.block1, function (option) {
            var left = option.size.left;

            _this5.selectRange[0] = _this5.getValueByDistance(left - _this5.leftDiffX);
            _this5.props.onProcess && _this5.props.onProcess(_this5.selectRange);
          });
        }
      }, this.state.timeout);
    }
  }, {
    key: 'weexStartHandler2',
    value: function weexStartHandler2() {
      var _this6 = this;

      if (isWeb) return;
      var dom = require('@weex-module/dom');
      this.paning = true;
      this.secondInterval = setInterval(function () {
        dom.getComponentRect(_this6.block2, function (option) {
          var left = option.size.left;

          _this6.selectRange[1] = _this6.getValueByDistance(left - _this6.leftDiffX);
          _this6.props.onProcess && _this6.props.onProcess(_this6.selectRange);
        });
      }, this.state.timeout);
    }
  }, {
    key: 'weexEndHandler',
    value: function weexEndHandler() {
      var _this7 = this;

      if (isWeb) return;
      this.paning = false;
      this.firstInterval && clearInterval(this.firstInterval);
      this.secondInterval && clearInterval(this.secondInterval);
      var slider = this.props.slider;

      var dom = require('@weex-module/dom');

      if (slider !== 'double') {
        setTimeout(function () {
          dom.getComponentRect(_this7.valueBar, function (option) {
            var value = _this7.getValueByDistance(option.size.width);
            _this7.props.onChange && _this7.props.onChange(value);
          });
        }, 50);
      } else {
        setTimeout(function () {
          dom.getComponentRect(_this7.block1, function (option) {
            var left = option.size.left;

            _this7.selectRange[0] = _this7.getValueByDistance(left - _this7.leftDiffX);
            _this7.props.onChange && _this7.props.onChange(_this7.selectRange);
          });
        }, 50);
      }
    }
  }, {
    key: 'bindExp',
    value: function bindExp() {
      var _this8 = this;

      var self = this;
      var slider = this.props.slider;

      if (this.props.disabled || isWeb) {
        return;
      }
      var blockMax1 = 0;
      if (slider === 'double') {
        blockMax1 = this.state.end - this.state.minDiffX;
      } else {
        blockMax1 = this.length;
      }
      var blockMax2 = this.length;
      var blockMin2 = this.state.start + this.state.minDiffX;
      var barMax1 = this.state.end;
      var barMax2 = this.length - this.state.start;
      // 滑块1表达式
      var expBlock1 = '{"type":"CallExpression","children":[{"type":"Identifier","value":"min"},{"type":"Arguments","children":[{"type":"NumericLiteral","value":' + blockMax1 + '},{"type":"CallExpression","children":[{"type":"Identifier","value":"max"},{"type":"Arguments","children":[{"type":"+","children":[{"type":"Identifier","value":"x"},{"type":"NumericLiteral","value":' + self.state.start + '}]},{"type":"NumericLiteral","value":0}]}]}]}]}';
      // 滑块2表达式
      var expBlock2 = '{"type":"CallExpression","children":[{"type":"Identifier","value":"min"},{"type":"Arguments","children":[{"type":"NumericLiteral","value":' + blockMax2 + '},{"type":"CallExpression","children":[{"type":"Identifier","value":"max"},{"type":"Arguments","children":[{"type":"+","children":[{"type":"Identifier","value":"x"},{"type":"NumericLiteral","value":' + self.state.end + '}]},{"type":"NumericLiteral","value":' + blockMin2 + '}]}]}]}]}';
      // valuebar表达式
      var expBar1 = '{"type":"CallExpression","children":[{"type":"Identifier","value":"min"},{"type":"Arguments","children":[{"type":"NumericLiteral","value":' + barMax1 + '},{"type":"CallExpression","children":[{"type":"Identifier","value":"max"},{"type":"Arguments","children":[{"type":"NumericLiteral","value":0},{"type":"-","children":[{"type":"NumericLiteral","value":' + self.state.barWidth + '},{"type":"Identifier","value":"x"}]}]}]}]}]}';
      // valuebar 范围表达式
      var expBar2 = '{"type":"CallExpression","children":[{"type":"Identifier","value":"min"},{"type":"Arguments","children":[{"type":"NumericLiteral","value":' + barMax2 + '},{"type":"CallExpression","children":[{"type":"Identifier","value":"max"},{"type":"Arguments","children":[{"type":"NumericLiteral","value":0},{"type":"+","children":[{"type":"NumericLiteral","value":' + self.state.barWidth + '},{"type":"Identifier","value":"x"}]}]}]}]}]}';

      if (slider !== 'double') {
        var args = [{
          element: this.block1.ref,
          property: 'transform.translateX',
          expression: expBlock1
        }, {
          element: this.valueBar.ref,
          property: 'width',
          expression: expBlock1
        }];
        expressionBinding && expressionBinding.createBinding(this.block1.ref, 'pan', '', args, function (e) {
          if (e.state === 'end') {
            _this8.paning = false;
            var range = self.getRange();
            // 限制diffX1范围
            _this8.setState({
              start: self.restrictValue(range.rangeX1, _this8.state.start + e.deltaX)
            });
            self.bindExp();
          }
        });
      } else {
        var _args = [{
          element: this.block1.ref,
          property: 'transform.translateX',
          expression: expBlock1
        }, {
          element: this.valueBar.ref,
          property: 'transform.translateX',
          expression: expBlock1
        }, {
          element: this.valueBar.ref,
          property: 'width',
          expression: expBar1
        }];
        var args2 = [{
          element: this.block2.ref,
          property: 'transform.translateX',
          expression: expBlock2
        }, {
          element: this.valueBar.ref,
          property: 'width',
          expression: expBar2
        }];
        expressionBinding && expressionBinding.createBinding(this.block1.ref, 'pan', '', _args, function (e) {
          if (e.state === 'end') {
            _this8.paning = false;
            var range = self.getRange();
            // 限制diffX1范围
            _this8.setState({
              start: _this8.restrictValue(range.rangeX1, _this8.state.start + e.deltaX),
              barWidth: _this8.restrictValue(range.rangeX1, _this8.state.barWidth - e.deltaX)
            });
            self.bindExp();
          }
        });
        expressionBinding && expressionBinding.createBinding(this.block2.ref, 'pan', '', args2, function (e) {
          if (e.state === 'end') {
            _this8.paning = false;
            var range = self.getRange();
            _this8.setState({
              end: self.restrictValue(range.rangeX2, _this8.state.end + e.deltaX),
              barWidth: _this8.restrictValue([0, _this8.length - _this8.state.start], _this8.state.barWidth + e.deltaX)
            });
            // 限制diffX1范围
            self.bindExp();
          }
        });
      }
    }
    // 获取diffx1 diffx2 取值范围

    // 限制取值范围

  }]);

  return Range;
}(_rax.Component);

Range.PropTypes = {
  slider: _rax.PropTypes.string,
  defaultValue: _rax.PropTypes.any,
  value: _rax.PropTypes.any,
  min: _rax.PropTypes.number,
  max: _rax.PropTypes.number,
  disabled: _rax.PropTypes.bool,
  highPerformance: _rax.PropTypes.bool,
  onChange: _rax.PropTypes.func,
  onProcess: _rax.PropTypes.func,
  style: _rax.PropTypes.obj,
  handlerStyle: _rax.PropTypes.obj,
  barStyle: _rax.PropTypes.obj,
  afterBarStyle: _rax.PropTypes.obj
};
Range.defaultProps = {
  slider: 'single',
  defaultValue: 0,
  min: 0,
  max: 100,
  disabled: false,
  highPerformance: true,
  handlerStyle: {},
  barStyle: {},
  afterBarStyle: {}
};
Range.displayName = 'Range';

var StyledRange = (0, _nukeThemeProvider.connectStyle)(_styles2.default, { withRef: true })(Range);

exports.default = StyledRange;
module.exports = exports['default'];