'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeEnv = require('nuke-env');

var _nukeEnv2 = _interopRequireDefault(_nukeEnv);

var _nukeThemeProvider = require('nuke-theme-provider');

var _nukeSwipe = require('nuke-swipe');

var _nukeSwipe2 = _interopRequireDefault(_nukeSwipe);

var _styles = require('../styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var appInfo = _nukeEnv2.default.appInfo;

var isIOS = appInfo.platform.toLowerCase() === 'ios';
/**
 * Range
 * @description  区间滑块
 */

var Range = function (_Component) {
  _inherits(Range, _Component);

  function Range(props) {
    _classCallCheck(this, Range);

    var _this = _possibleConstructorReturn(this, (Range.__proto__ || Object.getPrototypeOf(Range)).call(this, props));

    _this.webStart = _this.webStart.bind(_this);
    _this.webMove = _this.webMove.bind(_this);
    _this.webMove2 = _this.webMove2.bind(_this);
    _this.renderHandler = _this.renderHandler.bind(_this);
    _this.state = {
      start: 0,
      end: 0,
      active: false,
      value: props.value || props.defaultValue || 0,
      barWidth: 0,
      timeout: 100,
      left: 0,
      selectRange: [0, 0],
      minDiffX: 0
    };
    _this.selectRange = [0, 0];
    _this.dpr = 2;
    _this.ep = false;
    return _this;
  }

  _createClass(Range, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.block1 = (0, _rax.findDOMNode)(this.refs['slide-block-1']); // 左侧滑块
      this.block2 = (0, _rax.findDOMNode)(this.refs['slide-block-2']); // 右侧滑块
      this.valueBar = (0, _rax.findDOMNode)(this.refs['slide-value-bar']); // 黄色值条
      this.barContainer = (0, _rax.findDOMNode)(this.refs['slide-bar-container']); // 滚动条容器

      this.initBaseEnv(); // ep设置，滑块位置
    }
    // 根据value和length计算x方向偏移值

  }, {
    key: 'getDistanceByValue',
    value: function getDistanceByValue(value) {
      return (value - this.props.min) / (this.props.max - this.props.min) * this.length;
    }
  }, {
    key: 'getValueByDistance',
    value: function getValueByDistance(diffX) {
      return Math.round(diffX / this.length * (this.props.max - this.props.min) + this.props.min);
    }
  }, {
    key: 'initBaseEnv',
    value: function initBaseEnv() {
      var _props = this.props,
          slider = _props.slider,
          highPerformance = _props.highPerformance,
          min = _props.min,
          max = _props.max,
          themeStyle = _props.themeStyle,
          style = _props.style;

      this.length = parseInt(style.width || themeStyle.container.width, 10); // 可滑动的距离，未计算padding
      this.leftDiffX = 0;
      var newData = { selectRange: this.state.selectRange };
      if (!slider || slider === 'single') {
        newData.start = this.getDistanceByValue(this.state.value);
      } else if (slider === 'double') {
        newData.start = this.getDistanceByValue(this.state.value[0]);
        newData.end = this.getDistanceByValue(this.state.value[1]);
        newData.barWidth = newData.end - newData.start;
        this.selectRange = this.state.value || this.state.defaultValue;
        newData.minDiffX = this.state.minDiffX / (max - min) * this.length;
      } else {
        throw new Error('unsupport slider type,use single or double replace');
      }
      if (appInfo.platform === 'android') {
        newData.timeout = 250;
      }
      this.setState(_extends({}, newData));
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (nextProps.value != this.props.value && !this.paning) {
        this.setState({
          value: nextProps.value
        }, function () {
          _this2.initBaseEnv();
        });
      }
    }
  }, {
    key: 'computeContainerStyle',
    value: function computeContainerStyle() {
      var _props2 = this.props,
          handlerStyle = _props2.handlerStyle,
          style = _props2.style,
          themeStyle = _props2.themeStyle;

      var handlerWidth = handlerStyle.width ? handlerStyle.width : themeStyle.slideBlock.width;
      var handlerHeight = handlerStyle.height ? handlerStyle.height : themeStyle.slideBlock.height;
      return _extends({}, style, {
        width: this.length + handlerWidth,
        height: handlerHeight
      });
    }
  }, {
    key: 'computRangeBarStyle',
    value: function computRangeBarStyle() {
      var _props3 = this.props,
          afterBarStyle = _props3.afterBarStyle,
          themeStyle = _props3.themeStyle;

      return _extends({}, themeStyle.bar, themeStyle.invalid, afterBarStyle, {
        width: this.length
      });
    }
  }, {
    key: 'computValueBarStyle',
    value: function computValueBarStyle() {
      var left = 0;
      var width = 0;
      var _props4 = this.props,
          slider = _props4.slider,
          disabled = _props4.disabled,
          barStyle = _props4.barStyle,
          themeStyle = _props4.themeStyle;

      if (!slider || slider === 'single') {
        width = this.state.start;
      } else {
        left = this.state.start;
        width = this.state.end - this.state.start;
      }
      return Object.assign({}, themeStyle.bar, {
        width: width,
        transform: 'translateX(' + left / this.dpr + 'px)'
      }, disabled ? themeStyle.disabled : themeStyle.valid, barStyle);
    }
  }, {
    key: 'computBlock1Style',
    value: function computBlock1Style() {
      return { transform: 'translateX(' + this.state.start / this.dpr + 'px)' };
    }
  }, {
    key: 'computBlock2Style',
    value: function computBlock2Style() {
      return { transform: 'translateX(' + this.state.end / this.dpr + 'px)' };
    }
  }, {
    key: 'renderHandler',
    value: function renderHandler() {
      var _props5 = this.props,
          handlerStyle = _props5.handlerStyle,
          style = _props5.style,
          slider = _props5.slider,
          themeStyle = _props5.themeStyle;
      // native handle

      var blockEle1Style = Object.assign({}, themeStyle.slideBlock, isIOS ? themeStyle.slideBlockIOS : {}, handlerStyle, this.computBlock1Style());
      var blockEle2Style = Object.assign({}, themeStyle.slideBlock, isIOS ? themeStyle.slideBlockIOS : {}, handlerStyle, this.computBlock2Style());
      // h5 handle
      var webBlockEle1Style = _extends({}, blockEle1Style, {
        positon: 'absolute'
      });
      var webBlockEle2Style = _extends({}, blockEle2Style, {
        positon: 'absolute'
      });

      var webBlockEle1 = (0, _rax.createElement)(_nukeSwipe2.default, {
        ref: 'slide-block-1',
        onSwipeBegin: this.webStart,
        onSwipe: this.webMove,
        onEnd: this.webEnd,
        horizontalThreshold: 10,
        initialVelocityThreshold: 0.01,
        vertical: false,
        handlerStyle: webBlockEle1Style
      });
      var webBlockEle2 = (0, _rax.createElement)(_nukeSwipe2.default, {
        ref: 'slide-block-2',
        onSwipeBegin: this.webStart,
        onSwipe: this.webMove2,
        onSwipeEnd: this.webEnd,
        horizontalThreshold: 10,
        initialVelocityThreshold: 0.01,
        handlerStyle: webBlockEle2Style
      });

      if (slider !== 'double') {
        return webBlockEle1;
      }
      return [webBlockEle1, webBlockEle2];
    }
  }, {
    key: 'render',
    value: function render() {
      var _props6 = this.props,
          style = _props6.style,
          disabled = _props6.disabled,
          slider = _props6.slider,
          handlerStyle = _props6.handlerStyle,
          themeStyle = _props6.themeStyle,
          others = _objectWithoutProperties(_props6, ['style', 'disabled', 'slider', 'handlerStyle', 'themeStyle']);

      return (0, _rax.createElement)(
        _nukeView2.default,
        {
          ref: 'slide-bar-container',
          style: [themeStyle.container, this.computeContainerStyle()]
        },
        (0, _rax.createElement)(
          _nukeView2.default,
          { style: [themeStyle.range, this.computRangeBarStyle()] },
          (0, _rax.createElement)(
            _nukeView2.default,
            { ref: 'slide-value-bar', style: [this.computValueBarStyle()] },
            (0, _rax.createElement)(_nukeView2.default, { ref: 'slide-value-bar-2' })
          )
        ),
        this.renderHandler()
      );
    }
  }, {
    key: 'webStart',
    value: function webStart(e) {
      this.webDiffX = e.distance;
    }
  }, {
    key: 'webMove',
    value: function webMove(e) {
      var distance = e.distance - this.webDiffX;
      this.webDiffX = e.distance;
      var start = this.state.start + distance * this.dpr;
      if (this.props.slider !== 'double') {
        if (start > this.length || start < 0) return;
      } else if (start > this.state.end - this.state.minDiffX || start < 0) {
        return;
      }
      this.setState({
        start: start
      });
      this.props.onProcess && this.props.onProcess(this.getValueByDistance(start));
    }
  }, {
    key: 'webMove2',
    value: function webMove2(e) {
      var distance = e.distance - this.webDiffX;
      this.webDiffX = e.distance;
      var end = this.state.end + distance * this.dpr;
      if (this.props.slider !== 'double') {
        if (end > this.length || end < 0) return;
      } else if (end > this.length || end < this.state.start) {
        return;
      }
      this.setState({
        end: end
      });
      this.props.onProcess && this.props.onProcess([this.getValueByDistance(this.state.start), this.getValueByDistance(end)]);
    }
  }, {
    key: 'webEnd',
    value: function webEnd() {}
  }]);

  return Range;
}(_rax.Component);

Range.PropTypes = {
  slider: _rax.PropTypes.string,
  defaultValue: _rax.PropTypes.any,
  value: _rax.PropTypes.any,
  min: _rax.PropTypes.number,
  max: _rax.PropTypes.number,
  disabled: _rax.PropTypes.bool,
  highPerformance: _rax.PropTypes.bool,
  onChange: _rax.PropTypes.func,
  onProcess: _rax.PropTypes.func,
  style: _rax.PropTypes.obj,
  handlerStyle: _rax.PropTypes.obj,
  barStyle: _rax.PropTypes.obj,
  afterBarStyle: _rax.PropTypes.obj
};
Range.defaultProps = {
  slider: 'single',
  defaultValue: 0,
  min: 0,
  max: 100,
  disabled: false,
  highPerformance: true,
  handlerStyle: {},
  barStyle: {},
  afterBarStyle: {}
};
Range.displayName = 'Range';

var StyledRange = (0, _nukeThemeProvider.connectStyle)(_styles2.default, { withRef: true })(Range);

exports.default = StyledRange;
module.exports = exports['default'];