import VariableFactory from './variable';

function styleProvider(theme = {}) {
  const Variables = VariableFactory(theme);
  return {
    Range: {
      root: {
        userSelect: 'none',
      },
      bar: {
        height: Variables['bar-height'],
      },

      container: {
        height: Variables['handler-size'],
        display: 'flex',
        justifyContent: 'center',
        alignItems: 'center',
      },
      disabled: {
        backgroundColor: Variables['disabled-handler-bg-color'],
      },
      valid: {
        backgroundColor: Variables['bar-overlay-color'],
      },
      invalid: {
        flexDirection: 'row',
        overflow: 'hidden',
        backgroundColor: '#E0E0E0',
      },
      slideBlock: {
        width: Variables['handler-size'],
        height: Variables['handler-size'],
        backgroundColor: Variables['handler-bg-color'],
        borderRadius: Variables['handler-size'],
        position: 'absolute',
        left: 0,
        bottom: 0,
        borderColor: Variables['handler-border-color'],
        borderWidth: Variables['handler-border-width'],
        borderStyle: 'solid',
      },

      slideBlockIOS: {
        // borderColor: Variables['handler-border-color'],
        // borderWidth: Variables['handler-border-width'],
        // borderStyle: 'solid',
        // boxShadow: '0px 1px 3px rgba(0, 0, 0, 0.32)',
        boxShadow: '0 6px 12px rgba(0, 0, 0, 0.05)',
      },
    },
  };
}
module.exports = styleProvider;
