/** @jsx createElement */
import { createElement, Component, render } from 'rax';
import Range from 'nuke-range';
import { StyleProvider } from 'nuke-theme-provider';
import {
  decodeVar,
  DemoContainer,
  DemoSection,
  Demo,
  DemoItem,
  initDemo,
} from '@alife/nuke-demo-helper';

const App = class NukeDemoIndex extends Component {
  constructor() {
    super();
    this.state = {
      value: 50,
    };
  }

  changeValue() {
    this.setState({
      value: 100,
    });
  }

  onChange(value) {
    console.log('拖动停止', value);
    this.setState({
      value,
    });
  }
  onProcess(value) {
    console.log(value);
    this.setState({
      value,
    });
  }
  render() {
    return (
      <StyleProvider style={decodeVar(this.props.variable)}>
        <DemoContainer>
          <DemoSection title="单个滑块">
            <Demo>
              <DemoItem direction="column">
                <Range
                  slider="single"
                  min={0}
                  max={100}
                  style={{ width: 500 }}
                  highPerformance
                />
              </DemoItem>
            </Demo>
          </DemoSection>
          <DemoSection title="单个滑块，有默认值">
            <Demo>
              <DemoItem direction="column">
                <Range
                  slider="single"
                  min={0}
                  max={100}
                  defaultValue={80}
                  style={{ width: 500 }}
                  highPerformance
                />
              </DemoItem>
            </Demo>
          </DemoSection>
          <DemoSection title="两个滑块">
            <Demo>
              <DemoItem direction="column">
                <Range
                  slider="double"
                  min={0}
                  max={100}
                  value={[10, 80]}
                  style={{ width: 500 }}
                />
              </DemoItem>
            </Demo>
          </DemoSection>
          <DemoSection title="禁用">
            <Demo>
              <DemoItem direction="column">
                <Range
                  disabled
                  min={0}
                  max={100}
                  value={[10]}
                  style={{ width: 500 }}
                />
              </DemoItem>
            </Demo>
          </DemoSection>
        </DemoContainer>
      </StyleProvider>
    );
  }
};

window.renderDemo = function (lang, variable) {
  render(<App variable={variable} />);
};

renderDemo('en-us', window.THEME_VARIABLE);

initDemo('range');
